Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 358117)
+++ channels/chan_sip.c	(working copy)
@@ -30385,16 +30385,40 @@
 
 	if (instance) {
 		changed |= ast_rtp_instance_get_and_cmp_remote_address(instance, &p->redirip);
+
+		/* Prevent audio RTCP reads */
+		ast_channel_set_fd(chan, 1, -1);
+		/* Silence RTCP while audio RTP is inactive */
+		ast_rtp_instance_set_prop(instance, AST_RTP_PROPERTY_RTCP, 0);
 	} else if (!ast_sockaddr_isnull(&p->redirip)) {
 		memset(&p->redirip, 0, sizeof(p->redirip));
 		changed = 1;
+
+		/* Enable RTCP since it will be inactive if we're coming back
+		 * from a reinvite */
+		ast_rtp_instance_set_prop(instance, AST_RTP_PROPERTY_RTCP, 1);
+		/* Enable audio RTCP reads */
+		ast_channel_set_fd(chan, 1, ast_rtp_instance_fd(instance, 1));
 	}
+
 	if (vinstance) {
 		changed |= ast_rtp_instance_get_and_cmp_remote_address(vinstance, &p->vredirip);
+
+		/* Prevent video RTCP reads */
+		ast_channel_set_fd(chan, 3, -1);
+		/* Silence RTCP while video RTP is inactive */
+		ast_rtp_instance_set_prop(vinstance, AST_RTP_PROPERTY_RTCP, 0);
 	} else if (!ast_sockaddr_isnull(&p->vredirip)) {
 		memset(&p->vredirip, 0, sizeof(p->vredirip));
 		changed = 1;
+
+		/* Enable RTCP since it will be inactive if we're coming back
+		 * from a reinvite */
+		ast_rtp_instance_set_prop(vinstance, AST_RTP_PROPERTY_RTCP, 1);
+		/* Enable video RTCP reads */
+		ast_channel_set_fd(chan, 3, ast_rtp_instance_fd(vinstance, 1));
 	}
+
 	if (tinstance) {
 		changed |= ast_rtp_instance_get_and_cmp_remote_address(tinstance, &p->tredirip);
 	} else if (!ast_sockaddr_isnull(&p->tredirip)) {
